//
//              Copyright 2004 (C) by UCAR
//


#ifndef ATDISFF_RAWSAMPLESOCKETREOPENER_H
#define ATDISFF_RAWSAMPLESOCKETREOPENER_H

#include <atdUtil/Thread.h>

namespace atdISFF {

class RawSampleSocket;

/**
 * A detached thread that will keep trying to open the RawSampleSocket.
 * Since it is a detached thread, the destructor will be called
 * after completion of the run method, so this shouldn't be
 * deleted by the user.
 */
class RawSampleSocketReOpener: public atdUtil::Thread {
public:
  RawSampleSocketReOpener(RawSampleSocket* skt);
  ~RawSampleSocketReOpener();

  int run() throw(atdUtil::Exception);

private:
  RawSampleSocket* socket;
};

}

#endif
