/*              Copyright 2004 (C) by UCAR
 *
 * Description:
 *
 */

#ifndef ATDISFF_LICOR820SENSORPORT_H
#define ATDISFF_LICOR820SENSORPORT_H

#include <atdISFF/AsciiSensorPort.h>
#include <atdUtil/XMLSAX2Parser.h>
#include <atdISFF/licor820/Licor820SAX2Handler.h>

namespace atdISFF {
class Licor820SensorPort : public AsciiSensorPort {

public:
  Licor820SensorPort(const std::string portName,int channel)
    throw (atdUtil::IOException);
  ~Licor820SensorPort();

  virtual void init() throw(atdUtil::IOException);

  void processInput(isff_sys_time_t time, const char *charP)
  	throw(atdUtil::IOException);

  long getSampleTime() const { return sampleTime; }

  void setInitFile(const std::string& val) {
    initFile = val;
  }
  void sendInitFile() throw(atdUtil::IOException);

public:

protected:

  atdUtil::XMLSAX2Parser* parser;
  Licor820SAX2Handler* handler;

  long sampleTime;

  std::string initFile;

};
}

#endif

